/* SPDX-License-Identifier: GPL-2.0 */

/*
 * Copyright(C) 2024, D-Robotics Co., Ltd. All rights reserved
 */

#ifndef __DRB_X5_CLOCK_H
#define __DRB_X5_CLOCK_H

#define X5_OSC_SEL			0
#define X5_AON_APB0_CLK			1
#define X5_AON_MEM_CLK			2
#define X5_AON_PMU_CNT_CLK		3
#define X5_AON_MEM_NOC_CLK		4
#define X5_AON_PMU_PCLK			5
#define X5_AON_SRAM_CLK			6
#define X5_AON_GPIO_PCLK		7
#define X5_AON_RTC_CLK			8
#define X5_AON_RTC_PCLK			9
#define X5_AON_CRM_PCLK			10
#define X5_AON_SLCR_CLK			11

#define X5_AON_END_CLK			12

#define X5_DSP_PLL_P			0
#define X5_DSP_PLL_R			1
#define X5_DSP_NOC_CLK			2
#define X5_DSP_APB_CLK			3
#define X5_DSP_HIFI5_GCLK		4
#define X5_DSP_HIFI5_APB_CLK		5
#define X5_DSP_DMA_AXI_CLK		6
#define X5_DSP_PDM_HMCLKA_CLK		7

#define X5_DSP_I2S0_GEN_SCLK		8
#define X5_DSP_I2S0_GEN_MCLK		9
#define X5_DSP_I2S1_GEN_SCLK		10
#define X5_DSP_I2S1_GEN_MCLK		11
#define X5_DSP_TIMER_CLK		12

#define X5_DSP_HIFI5_CHILD_CLK		13
#define X5_DSP_I2S0_CHILD_SCLK		14
#define X5_DSP_I2S0_CHILD_MCLK		15
#define X5_DSP_I2S1_CHILD_SCLK		16
#define X5_DSP_I2S1_CHILD_MCLK		17

#define X5_DSP_SRAM0_CLK		18
#define X5_DSP_SRAM1_CLK		19
#define X5_DSP_HIFI5_CLK		20
#define X5_DSP_HIFI5_BUS_CLK		21

#define X5_DSP_DMA_PCLK			22
#define X5_DSP_PDM_APB_CLK		23
#define X5_DSP_TIMER1_PCLK		24
#define X5_DSP_GPIO_PCLK		25
#define X5_DSP_UART_CLK			26
#define X5_DSP_I2S0_SCLK		27
#define X5_DSP_I2S0_MCLK		28
#define X5_DSP_I2S0_PCLK		29
#define X5_DSP_I2S1_SCLK		30
#define X5_DSP_I2S1_MCLK		31
#define X5_DSP_I2S1_PCLK		32
#define X5_DSP_I2C_PCLK			33
#define X5_DSP_SPI_PCLK			34
#define X5_DSP_MAILBOX_ACLK		35

#define X5_DSP_I2S0_MUX_SCLK		36
#define X5_DSP_I2S1_MUX_SCLK		37

#define X5_DSP_END_CLK			38

#define X5_CPU_PLL_P			0
#define X5_CPU_PLL_R			1
#define X5_SYS0_PLL_P			2
#define X5_SYS0_PLL_R			3
#define X5_SYS1_PLL_P			4
#define X5_SYS1_PLL_R			5
#define X5_DISP_PLL_P			6
#define X5_DISP_PLL_R			7
#define X5_PIXEL_PLL_P			8
#define X5_PIXEL_PLL_R			9

#define X5_TOP_NOC_CLK			10
#define X5_BPU_NOC_CLK			11
#define X5_CODEC_NOC_CLK		12
#define X5_GPU_NOC_CLK			13
#define X5_ROM_ACLK			14
#define X5_TOP_APB_CLK			15

#define X5_WDT_PCLK			16
#define X5_DMA_PCLK			17
#define X5_TOP_TIMER0_PCLK		18
#define X5_TOP_TIMER1_PCLK		19
#define X5_TOP_PVT_PCLK			20
#define X5_HISPEED_MS_CFG_CLK		21

#define X5_CPU_CORE_CLK			22
#define X5_CPU_SCLK			23
#define X5_CPU_PCLK			24
#define X5_CPU_ATCLK			25
#define X5_CPU_PERI_CLK			26
#define X5_CSS600_TSGEN_CLK		27
#define X5_CSS600_DBG_CLK		28
#define X5_CSS600_TRACE_CLK		29
#define X5_CSS600_TPIU_CLK		30
#define X5_CPU_GIC_CLK			31
#define X5_CPU_NOC_CLK			32

#define X5_CAM_ISP8000_CORE_CLK		33
#define X5_CAM_ISP8000_AXI_CLK		34
#define X5_CAM_CSI0_IPI_CLK		35
#define X5_CAM_CSI1_IPI_CLK		36
#define X5_CAM_CSI2_IPI_CLK		37
#define X5_CAM_CSI3_IPI_CLK		38
#define X5_CAM_CSI_TX_CLK		39
#define X5_CAM_SIF_AXI_CLK		40
#define X5_CAM_DEWARP_CORE_CLK		41
#define X5_CAM_DEWARP_AXI_CLK		42
#define X5_CAM_VSE_CORE_CLK		43
#define X5_CAM_VSE_UPSCALE_CLK		44
#define X5_CAM_VSE_AXI_CLK		45

#define X5_CAM_ISP8000_CLK		46
#define X5_CAM_ISP8000_MCM_CLK		47
#define X5_CAM_ISP8000_S_HCLK		48
#define X5_CAM_CSI0_PCLK		49
#define X5_CAM_CSI1_PCLK		50
#define X5_CAM_CSI2_PCLK		51
#define X5_CAM_CSI3_PCLK		52
#define X5_CAM_CSI0_CFG_CLK		53
#define X5_CAM_CSI1_CFG_CLK		54
#define X5_CAM_CSI2_CFG_CLK		55
#define X5_CAM_CSI3_CFG_CLK		56
#define X5_CAM_SIF_PCLK			57
#define X5_CAM_DEWARP_HCLK		58

#define X5_DISP_BT1120_PIXEL_CLK	59
#define X5_DISP_DC8000_PIXEL_CLK	60
#define X5_DISP_SIF_ACLK		61
#define X5_DISP_BT1120_ACLK		62
#define X5_DISP_DC8000_ACLK		63

#define X5_DISP_CSI_PCLK		64
#define X5_DISP_DSI_PCLK		65
#define X5_DISP_DC8000_PCLK		66
#define X5_DISP_BT1120_PCLK		67
#define X5_DISP_DPHY_CFG_CLK		68
#define X5_DISP_SIF_PCLK		69
#define X5_DISP_GPIO_PCLK		70

#define X5_GPU_GC820_CLK		71
#define X5_GPU_GC8000L_CLK		72
#define X5_GPU_GC820_ACLK		73
#define X5_GPU_GC8000L_ACLK		74
#define X5_GPU_PCLK			75
#define X5_GPU_NOC_PCLK			76

#define X5_BPU_MCLK_2X			77
#define X5_BPU_SYS_TIMER_CLK		78
#define X5_BPU_APB_CLK			79
#define X5_BPU_MCLK_1X_CLK		80
#define X5_BPU_MCLK_2X_CLK		81

#define X5_VIDEO_CODEC_CORE_CLK		82
#define X5_VIDEO_CODEC_BCLK		83
#define X5_VIDEO_JPEG_CORE_CLK		84
#define X5_VIDEO_JPEG_CCLK		85
#define X5_VIDEO_JPEG_ACLK		86
#define X5_VIDEO_JPEG_PCLK		87
#define X5_VIDEO_CODEC_CCLK		88
#define X5_VIDEO_CODEC_ACLK		89
#define X5_VIDEO_CODEC_PCLK		90
#define X5_VIDEO_NOC_PCLK		91

#define X5_HSIO_QSPI_BUS_CLK		92
#define X5_HSIO_QSPI_CORE_CLK		93
#define X5_HSIO_ENET_AXI_CLK		94
#define X5_HSIO_ENET_RGMII_CLK		95
#define X5_HSIO_ENET_PTP_REFCLK		96
#define X5_HSIO_ENET_REF_CLK		97
#define X5_HSIO_ENET_PCLK		98

#define X5_HSIO_EMMC_AXI_CLK		99
#define X5_HSIO_EMMC_CCLK		100
#define X5_HSIO_EMMC_ACLK		101
#define X5_HSIO_EMMC_HCLK		102
#define X5_HSIO_EMMC_BCLK		103
#define X5_HSIO_EMMC_TCLK		104

#define X5_HSIO_SDIO0_AXI_CLK		105
#define X5_HSIO_SDIO0_CCLK		106
#define X5_HSIO_SDIO0_ACLK		107
#define X5_HSIO_SDIO0_HCLK		108
#define X5_HSIO_SDIO0_BCLK		109
#define X5_HSIO_SDIO0_TCLK		110

#define X5_HSIO_SDIO1_AXI_CLK		111
#define X5_HSIO_SDIO1_CCLK		112
#define X5_HSIO_SDIO1_ACLK		113
#define X5_HSIO_SDIO1_HCLK		114
#define X5_HSIO_SDIO1_BCLK		115
#define X5_HSIO_SDIO1_TCLK		116

#define X5_HSIO_24M_CLK			117
#define X5_HSIO_USB2_AXI_CLK		118
#define X5_HSIO_USB3_AXI_CLK		119
#define X5_HSIO_USB2_PCLK		120
#define X5_HSIO_USB3_PCLK		121
#define X5_HSIO_USB2_CTRL_REF_CLK	122
#define X5_HSIO_USB3_CTRL_REF_CLK	123
#define X5_HSIO_USB3_SUSPEND_CLK	124
#define X5_HSIO_GPIO0_PCLK		125
#define X5_HSIO_GPIO1_PCLK		126

#define X5_SEC_AXI_CLK			127
#define X5_SEC_APB_CLK			128
#define X5_LSIO_LPWM0_CLK		129
#define X5_LSIO_LPWM1_CLK		130
#define X5_HPS_DMA_AXI_CLK		131
#define X5_TOP_TIMER0_CLK		132
#define X5_TOP_TIMER1_CLK		133
#define X5_LSIO_SENSOR0_CLK		134
#define X5_LSIO_SENSOR1_CLK		135
#define X5_LSIO_SENSOR2_CLK		136
#define X5_LSIO_SENSOR3_CLK		137
#define X5_BPU_NOC_PCLK			138
#define X5_LSIO_ADC_CLK			139

#define X5_LSIO_UART7_CLK		140
#define X5_LSIO_UART1_CLK		141
#define X5_LSIO_UART2_CLK		142
#define X5_LSIO_UART3_CLK		143
#define X5_LSIO_UART4_CLK		144
#define X5_LSIO_UART7_PCLK		145
#define X5_LSIO_UART1_PCLK		146
#define X5_LSIO_UART2_PCLK		147
#define X5_LSIO_UART3_PCLK		148
#define X5_LSIO_UART4_PCLK		149
#define X5_LSIO_SPI0_CLK		150
#define X5_LSIO_SPI1_CLK		151
#define X5_LSIO_SPI2_CLK		152
#define X5_LSIO_SPI3_CLK		153
#define X5_LSIO_SPI4_CLK		154
#define X5_LSIO_SPI5_CLK		155
#define X5_LSIO_LPWM0_PCLK		156
#define X5_LSIO_LPWM1_PCLK		157
#define X5_LSIO_GPIO0_PCLK		158
#define X5_LSIO_GPIO1_PCLK		159
#define X5_LSIO_I2C0_PCLK		160
#define X5_LSIO_I2C1_PCLK		161
#define X5_LSIO_I2C2_PCLK		162
#define X5_LSIO_I2C3_PCLK		163
#define X5_LSIO_I2C4_PCLK		164
#define X5_LSIO_PWM0_PCLK		165
#define X5_LSIO_PWM1_PCLK		166
#define X5_LSIO_PWM2_PCLK		167
#define X5_LSIO_PWM3_PCLK		168
#define X5_LSIO_PCLK			169

#define X5_LSIO_ADC_PCLK		170
#define X5_LSIO_UART5_PCLK		171
#define X5_LSIO_UART6_PCLK		172
#define X5_LSIO_UART5_CLK		173
#define X5_LSIO_UART6_CLK		174
#define X5_LSIO_I2C5_PCLK		175
#define X5_LSIO_I2C6_PCLK		176

#define X5_HPS_END_CLK			177

#endif
